"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EEExecutionsService = void 0;
const WorkflowHelpers_1 = require("../WorkflowHelpers");
const executions_service_1 = require("./executions.service");
const workflows_services_ee_1 = require("../workflows/workflows.services.ee");
const repositories_1 = require("../databases/repositories");
const typedi_1 = __importDefault(require("typedi"));
class EEExecutionsService extends executions_service_1.ExecutionsService {
    static async getWorkflowIdsForUser(user) {
        return (0, WorkflowHelpers_1.getSharedWorkflowIds)(user);
    }
    static async getExecution(req) {
        const execution = await super.getExecution(req);
        if (!execution)
            return;
        const workflow = typedi_1.default.get(repositories_1.WorkflowRepository).create(execution.workflowData);
        workflows_services_ee_1.EEWorkflowsService.addOwnerAndSharings(workflow);
        await workflows_services_ee_1.EEWorkflowsService.addCredentialsToWorkflow(workflow, req.user);
        execution.workflowData = workflow;
        return execution;
    }
}
exports.EEExecutionsService = EEExecutionsService;
//# sourceMappingURL=executions.service.ee.js.map