"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.selectListQueryMiddleware = void 0;
const error_1 = require("./error");
const n8n_workflow_1 = require("n8n-workflow");
const workflow_schema_1 = require("./workflow.schema");
const utils = __importStar(require("../../utils"));
function toQuerySelect(rawSelect, schema) {
    const asArr = (0, n8n_workflow_1.jsonParse)(rawSelect, { errorMessage: 'Failed to parse select JSON' });
    if (!utils.isStringArray(asArr)) {
        throw new Error('Parsed select is not a string array');
    }
    return asArr.reduce((acc, field) => {
        if (!schema.fieldNames.includes(field))
            return acc;
        return (acc[field] = true), acc;
    }, {});
}
const selectListQueryMiddleware = (req, res, next) => {
    const { select: rawSelect } = req.query;
    if (!rawSelect)
        return next();
    let schema;
    if (req.baseUrl.endsWith('workflows')) {
        schema = workflow_schema_1.WorkflowSchema;
    }
    else {
        return next();
    }
    try {
        const select = toQuerySelect(rawSelect, schema);
        if (Object.keys(select).length === 0)
            return next();
        req.listQueryOptions = { ...req.listQueryOptions, select };
        next();
    }
    catch (error) {
        (0, error_1.handleListQueryError)('select', rawSelect, error);
    }
};
exports.selectListQueryMiddleware = selectListQueryMiddleware;
//# sourceMappingURL=select.js.map